import org.junit.jupiter.api.*;
import static org.junit.jupiter.api.Assertions.*;
import java.util.*;

public class Testing {

    @Test
    @DisplayName("Book 2 string constructor")
    public void testBook2String() {
        Book book = new Book("Title", "Author");

        // Change the following to test that getTitle returns "Title"
        assertEquals("Title", null);

        // Change the following to test that getArtistst returns a list
        // containing "Author"
        assertEquals(List.of("Author"), null);

        // Change the following to test that toString returns the correctly
        // String representation
        assertEquals("Title by [Author]", null);
    }

    @Test
    @DisplayName("Book string, list constructor")
    public void testBookStringList() {
        Book book = new Book("Title", List.of("Author 1", "Author 2"));

        // TODO: Test that getTitle returns "Title"
        assertTrue(false);

        // TODO: Test that getArtistst returns a list containing
        // "Author 1" and "Author 2"
        assertTrue(false);

        // TODO: Test that toString returns the correctly
        // String representation
        assertTrue(false);
    }

    @Test
    @DisplayName("createIndex tests")
    public void testInvertedIndex() {
        Book mistborn = new Book("Mistborn", "Brandon Sanderson",
                                 new Scanner("Epic fantasy worldbuildling content"));
        Book farenheit = new Book("Farenheit 451", "Ray Bradbury",
                                  new Scanner("Realistic \"sci-fi\" content"));
        Book hobbit = new Book("The Hobbit", "J.R.R. Tolkein",
                               new Scanner("Epic fantasy quest content"));
        
        List<Media> books = List.of(mistborn, farenheit, hobbit);
        Map<String, Set<Media>> index = InvertedIndex.createIndex(books);
        
        // Change the following assertNull statements so this tests the quotes around
        // sci-fi aren't ignored
        assertNull(index.containsKey("sci-fi"));
        assertNull(index.containsKey("\"sci-fi\""));

        // Change the following line such that following test passes
        // (what original books include 'fantasy'?)
        Set<Book> expected = Set.of(mistborn, farenheit, hobbit);
        assertEquals(expected, index.get("fantasy"));
    }
}
